using System;
using UnityEngine;


namespace Romfarer {

	/*
	class Controllers {
		
		public Controllers() {}
		
		public static Vector3 MissileControl(Part mod, Component target, Vector3 beamRide, IPid p1, IPid p2, float pdRange = 0){
			float thrust = mod.Modules["LazorControlT2"].Fields.GetValue<float>("maxThrust");
			float torque = mod.Modules["LazorControlT2"].Fields.GetValue<float>("maxTorque");
			
			Vector3 lastAimpoint = mod.Modules["LazorControlT2"].Fields.GetValue<Vector3>("lastAimpoint");
			Vector3 lastVelocity = mod.Modules["LazorControlT2"].Fields.GetValue<Vector3>("lastVelocity");
			Vector3 Vm = mod.vessel.orbit.GetVel() - mod.vessel.mainBody.getRFrmVel(mod.transform.position);
			Vector3 Vm2 = mod.vessel.orbit.GetVel() - mod.vessel.mainBody.getRFrmVel(mod.transform.position);
			Vector3 R = Vector3.zero;
			Vector3 Vt = Vector3.zero;
			if (target == null) { //aim mode depends on system.Target
				R = beamRide * 750f;
			} else {
				//proximity detonation
				if (pdRange != 0 && (mod.transform.position - target.transform.position).magnitude < pdRange) {
					mod.Modules.Send("Detonate");
					MonoBehaviour.print("DETONATE " + (mod.transform.position - target.transform.position).magnitude);
				}
				if (target is Vessel) {
					Vessel vessel = (Vessel)target;
					Vt = vessel.orbit.GetVel() - vessel.mainBody.getRFrmVel(vessel.CoM);
					Vm2 -= Vt;
					Vt -= Vm; //velocity of target in relation to missile
					R = vessel.CoM - mod.vessel.CoM; //position of target in relation to missile
				} else {
					
					Vt = Vector3.zero - Vm;
					R = target.transform.position - mod.transform.position; //position of target in relation to missile
				}
			}
			
			//start vacuum guidance code
			if(lastAimpoint == Vector3.zero) {
				lastAimpoint = R;
			}
			
			Vector3 aimRelPos = (R + lastAimpoint) / 2;
			
			double accel = Math.Abs(Vt.magnitude - lastVelocity.magnitude);
			
			double part1 = -1.0 * Vt.magnitude;
			double part2 = Mathf.Pow(Vt.magnitude,2) + 2 * accel * aimRelPos.magnitude;
			double part3 = accel;
			
			Vector3 vac_angle;
			if(part2 > 0) { //make sure there's a plottable solution
				double part2s = Math.Sqrt(part2);
				double timeToIntercept;
				if(part1 + part2s > 0) {
					timeToIntercept = (part1 + part2s) / part3;
				}
				else if (part1 - part2s > 0) {
					timeToIntercept = (part1 - part2s) / part3;
				}
				else {
					//if both times are negative, average them, make them positive, and pray?
					timeToIntercept = Math.Abs( (part1 + part2s) + (part1 - part2s) )/ (2 * part3);
				}
				
				vac_angle = (Vt * (float)timeToIntercept) + aimRelPos;
				
				mod.Modules["LazorControlT2"].Fields.SetValue<Vector3>("lastAimpoint", vac_angle);
				mod.Modules["LazorControlT2"].Fields.SetValue<Vector3>("lastVelocity", Vt);
			}
			else { //if not, aim at target and hope a plottable solution arises en-route.
				vac_angle = R;
				mod.Modules["LazorControlT2"].Fields.SetValue<Vector3>("lastAimpoint", Vector3.zero);
				mod.Modules["LazorControlT2"].Fields.SetValue<Vector3>("lastVelocity", Vector3.zero);
			}
			//end vacuum guidance code
			
			//start atmospheric guidance code
			Vector3 atmo_angle;
			Vector3 LOS = Vector3.Cross(Vm2, R) / (R.magnitude * R.magnitude);
			Vector3 acc = 60 * Vector3.Cross(Vm2, LOS); 
			float vel_offset = Vector3.Angle(Vm2, R); //the angular error
			atmo_angle = Vm2 - (acc);
			//end atmospheric guidance code
			
			//start atmo/vacuum weighting
			double atmWeight = mod.vessel.atmDensity / 1.2;
			if(atmWeight > 1.0)
			{
				atmWeight = 1.0;
			}
			double vacWeight = 1.0 - atmWeight;
			
			Vector3 lead_angle = (vac_angle.normalized * (float)vacWeight) + (atmo_angle.normalized * (float)atmWeight);
			//end atmo/vacuum weighting

			
			float dir_pitch = 0;
			float dir_yaw = 0;
			Util.PitchYawAngle(mod.transform, lead_angle.normalized, out dir_pitch, out dir_yaw);
			float p = 0;
			float y = 0;
			float a = Math.Abs(dir_pitch);
			float ai = 180 - a;  //float ai = Mathf.PI - a;
			float b = Math.Abs(dir_yaw);
			float bi = 180 - b; //float bi = Mathf.PI - b;
			float min = Math.Min(Math.Min(a, ai), Math.Min(b, bi));
			if (min == a) {
				p = dir_pitch;
				y = dir_yaw;
			} else if (min == b) {
				p = dir_pitch;
				y = dir_yaw;
			} else if (min == ai) {
				p = -dir_pitch;
				y = dir_yaw;
			} else if (min == bi) {
				p = dir_pitch;
				y = -dir_yaw;
			}
			Vector3 torqueOut = new Vector3(0, 0, 0);
			torqueOut.z = p1.Update(- y, Time.deltaTime);
			torqueOut.x = p2.Update(p, Time.deltaTime);
			torqueOut.y = -mod.vessel.angularVelocity.y / 100;
			

			
			return torqueOut;
			
			
			
		}
		
		
	}

*/

	class Controllers {

		public Controllers() {}

		public static Vector3 MissileControl(Part mod, Component target, Vector3 beamRide, IPid p1, IPid p2, float pdRange = 0){
			float thrust = mod.Modules["LazorControlT2"].Fields.GetValue<float>("maxThrust");
			float torque = mod.Modules["LazorControlT2"].Fields.GetValue<float>("maxTorque");
			Vector3 Vm = mod.vessel.orbit.GetVel() - mod.vessel.mainBody.getRFrmVel(mod.transform.position);
			Vector3 R = Vector3.zero;
			Vector3 Vt = Vector3.zero;
			if (target == null) { //aim mode depends on system.Target
				R = beamRide * 750f;
			} else {
				//proximity detonation
				if (pdRange != 0 && (mod.transform.position - target.transform.position).magnitude < pdRange) {
					mod.Modules.Send("Detonate");
					MonoBehaviour.print("DETONATE " + (mod.transform.position - target.transform.position).magnitude);
				}
				if (target is Vessel) {
					Vessel vessel = (Vessel)target;
					Vt = vessel.orbit.GetVel() - vessel.mainBody.getRFrmVel(vessel.CoM);
					Vm -= Vt; //velocity of missile in relation to target
					R = vessel.CoM - mod.vessel.CoM; //homing at target
				} else {
					R = target.transform.position - mod.transform.position; //homing at target
				}
			}

			Vector3 LOS = Vector3.Cross(Vm, R) / (R.magnitude * R.magnitude);
			Vector3 acc = 60 * Vector3.Cross(Vm, LOS); 
			float vel_offset = Vector3.Angle(Vm, R); //the angular error
			Vector3 lead_angle = Vm - (acc);
			float dir_pitch = 0;
			float dir_yaw = 0;
			Util.PitchYawAngle(mod.transform, lead_angle.normalized, out dir_pitch, out dir_yaw);
			float p = 0;
			float y = 0;
			float a = Math.Abs(dir_pitch);
			float ai = 180 - a;  //float ai = Mathf.PI - a;
			float b = Math.Abs(dir_yaw);
			float bi = 180 - b; //float bi = Mathf.PI - b;
			float min = Math.Min(Math.Min(a, ai), Math.Min(b, bi));
			if (min == a) {
				p = dir_pitch;
				y = dir_yaw;
			} else if (min == b) {
				p = dir_pitch;
				y = dir_yaw;
			} else if (min == ai) {
				p = -dir_pitch;
				y = dir_yaw;
			} else if (min == bi) {
				p = dir_pitch;
				y = -dir_yaw;
			}
			Vector3 torqueOut = new Vector3(0, 0, 0);
			torqueOut.z = p1.Update(- y, Time.deltaTime);
			torqueOut.x = p2.Update(p, Time.deltaTime);
			torqueOut.y = -mod.vessel.angularVelocity.y / 100;

			//MonoBehaviour.print(
				//" " + dir_pitch.ToString("f5") + 
				//" " + dir_yaw.ToString("f5") +
				//" V°: " + vel_offset.ToString("f3") +
				//" V: " + Vm.magnitude.ToString("f3") + 
				//" |a|: " + acc.magnitude.ToString("f3") + 
				//" |R|: " + R.magnitude);

			return torqueOut;
		}

		public static Vector3 StopSpin(Transform transform, Vector3 direction, Vector3 angVel, Vector3 angMom, Vector3 moi, float maxForce, float force){
			float needed_pitch = 0;
			float needed_yaw = 0;
			Util.PitchYawAngle(transform, direction, out needed_pitch, out needed_yaw);
			needed_pitch *= Mathf.Deg2Rad;
			needed_yaw *= Mathf.Deg2Rad;
			//float stop_pitch = (angVel.x * angVel.x) / ((2 * force * angVel.x) / angMom.x);
			//float stop_yaw = (angVel.z * angVel.z) / ((2 * force * angVel.z) / angMom.z);
			float stop_pitch = (angVel.x * moi.x) / (2 * force);
			float stop_yaw = (angVel.z * moi.z) / (2 * force);
			//find the axis with the shortest path to 0 or |180|
			float p = 0;
			float y = 0;
			float a = Math.Abs(needed_pitch);
			float ai = Mathf.PI - a;
			float b = Math.Abs(needed_yaw);
			float bi = Mathf.PI - b;
			float min = Math.Min(Math.Min(a, ai), Math.Min(b, bi));
			if (min == a) {
				p = needed_pitch;
				y = needed_yaw;
			} else if (min == b) {
				p = needed_pitch;
				y = needed_yaw;
			} else if (min == ai) {
				p = -needed_pitch;
				y = needed_yaw;
			} else if (min == bi) {
				p = needed_pitch;
				y = -needed_yaw;
			}
			Vector3 torque = new Vector3();

			/*if (stop_yaw < b)
				torque.z = Mathf.Clamp(-y * moi.z, -maxForce, maxForce);  //-y;
			else
				torque.z =  Mathf.Clamp(-angMom.z * force, -maxForce, maxForce); // -angMom.z;

			if (stop_pitch < a)
				torque.x = Mathf.Clamp(p * moi.x, -maxForce, maxForce);//p;
			else
				torque.x = Mathf.Clamp(-angMom.x * force, -maxForce, maxForce); // -angMom.x;

			torque.y = Mathf.Clamp(-angMom.y * force, -maxForce, maxForce); // -angMom.y; //ROLL
*/
			if (stop_yaw < b)
				torque.z = Mathf.Clamp((-y - angVel.z) * force, -maxForce, maxForce);  //-y;
			else
				torque.z =  Mathf.Clamp(-angVel.z * force, -maxForce, maxForce); // -angMom.z;
			
			if (stop_pitch < a)
				torque.x = Mathf.Clamp((p - angVel.x) * force, -maxForce, maxForce);//p;
			else
				torque.x = Mathf.Clamp(-angVel.x * force, -maxForce, maxForce); // -angMom.x;
			
			torque.y = Mathf.Clamp(-angMom.y * force, -maxForce, maxForce); // -angMom.y; //ROLL

			return torque;
			//MonoBehaviour.print(" tq " + torque + " vel " + targetVessel.angularVelocity + " mom " + targetVessel.angularMomentum);

		}
		
	}
}

