﻿/* Author: Jim-Kyrre Benjaminsen AKA Romfarer
 * License: This work is licensed under a Creative Commons Attribution-NonCommercial-NoDerivs 3.0 Unported License. 
 * http://creativecommons.org/licenses/by-nc-nd/3.0/
*/

using System;
using System.Collections.Generic;
using System.Text;

namespace Romfarer {
    class MVSchase : MVS {

        public MVSchase(LazorSystem system, List<LazorAimable> parts) : base(system, parts) { }

        override public void Activate() {
            foreach (LazorAimable l in parts) //make all lasers chase the leader
                l.Lazor.Aim(leader.GetAim());
        }

        override public void MoveUp() {
            mc.RotateUp(leader);
            foreach (LazorAimable l in parts)
                l.Lazor.Aim(leader.GetAim());
        }

        override public void MoveDown() {
            mc.RotateDown(leader);
            foreach (LazorAimable l in parts)
                l.Lazor.Aim(leader.GetAim());
        }

        override public void MoveLeft() {
            mc.RotateLeft(leader);
            foreach (LazorAimable l in parts)
                l.Lazor.Aim(leader.GetAim());
        }

        override public void MoveRight() {
            mc.RotateRight(leader);
            foreach (LazorAimable l in parts)
                l.Lazor.Aim(leader.GetAim());
        }

    }
}
