﻿/* Author: Jim-Kyrre Benjaminsen AKA Romfarer
 * License: This work is licensed under a Creative Commons Attribution-NonCommercial-NoDerivs 3.0 Unported License. 
 * http://creativecommons.org/licenses/by-nc-nd/3.0/
*/

using System;
using System.Collections.Generic;
using System.Text;
using UnityEngine;
using KSP.IO;


namespace Romfarer {

    static class Util {
        private static GUISkin lazorSkin;
        private static GUIStyle space_compact;
        private static GUIStyle space_formatted;
        private static GUIStyle button_header_minimize;
        private static GUIStyle button_header_close;
        private static GUIStyle button_color_red;
        private static GUIStyle button_color_blue;
        private static GUIStyle button_color_green;
        private static GUIStyle button_color_yellow;
        private static GUIStyle button_color_magenta;
        private static GUIStyle button_color_white;
        private static GUIStyle divider;

		//old gui
		private static GUIStyle stdLabelSmallCustom;
		private static GUIStyle button_bold;
		private static GUIStyle txtArea;
		private static GUIStyle parameters_highlight;
		private static GUIStyle listItem_std;
		private static GUIStyle label;
		private static Texture2D labelTexture;
		private static GUIStyle crosshairLabel;
		private static TimeSpan timeSpan;
		private static List<Part> childList;


		private static GUIStyle slider_balance;
		private static GUIStyle slider_balance_button;
		private static GUIStyle window_lazorButton;
		private static GUIStyle window_border;
		private static GUIStyle window_eva_mini;
		private static GUIStyle window_eva;
		private static GUIStyle button_lazorButton;

		private static GUIStyle button_floatingToggle;
		private static GUIStyle divider_gray_button;
		private static GUIStyle divider_gray;
		private static GUIStyle divider_directions_arrowBG;
		private static GUIStyle divider_directions_BG;
		private static GUIStyle parameters_normal;
		private static GUIStyle labelBold;
		private static GUIStyle buttons_arrows_mainPanel;
		private static GUIStyle button_toggle;
		private static GUIStyle listItemBG_compact;
		private static GUIStyle stdLabelSmallCustom_compact;
		static private Texture2D planetTexture;

		public static void ResetGUI(){
			lazorSkin = null;
			space_compact = null;
			space_formatted = null;
			button_header_minimize = null;
			button_header_close = null;
			button_color_red = null;
			button_color_blue = null;
			button_color_green = null;
			button_color_yellow = null;
			button_color_magenta = null;
			button_color_white = null;
			divider = null;
			stdLabelSmallCustom = null;
			button_bold = null;
			txtArea = null;
			parameters_highlight = null;
			listItem_std = null;
			label = null;
			labelTexture = null;
			crosshairLabel = null;

			slider_balance = null;
			slider_balance_button = null;
			window_lazorButton = null;
			window_border = null;
			window_eva_mini = null;
			window_eva = null;
			button_lazorButton = null;

			button_floatingToggle = null;
			divider_gray_button = null;
			divider_gray = null;
			divider_directions_arrowBG = null;
			divider_directions_BG = null;
			parameters_normal = null;
			labelBold = null;
			buttons_arrows_mainPanel = null;
			button_toggle = null;
			listItemBG_compact = null;
			stdLabelSmallCustom_compact = null;
			planetTexture = null;


		}

        public static GUISkin LazorSkin {
            get {
                if (lazorSkin == null) {
                    GUI.skin = null;
                    //lazorSkin = GUI.skin;
                    lazorSkin = (GUISkin)UnityEngine.Object.Instantiate(GUI.skin);
         
                    lazorSkin.name = "LazorSkin";

                    Texture2D bg = LoadTexture(64, 31, "gui_window_noborder.png");
                    lazorSkin.window.border = new RectOffset(30, 30, 23, 6);
                    lazorSkin.window.normal.background = bg;
                    lazorSkin.window.onNormal.background = bg;
                    lazorSkin.window.alignment = TextAnchor.UpperCenter;
                    lazorSkin.window.normal.textColor = Color.yellow;
                    lazorSkin.window.onNormal.textColor = Color.yellow;
                    lazorSkin.window.padding = new RectOffset(0, 0, 23, 10);
                    lazorSkin.window.margin = new RectOffset(0, 0, 0, 0);
                    lazorSkin.window.overflow = new RectOffset(0, 0, 0, 0);
                    lazorSkin.window.contentOffset = new Vector2(-3, -20);
                    lazorSkin.window.fontStyle = FontStyle.Bold;

                    Texture2D button = LoadTexture(32, 32, "gui_button.png");
                    Texture2D button_hover = LightTexture(button, 1.2f);
                    Texture2D button_on = LoadTexture(32, 32, "gui_button_on.png");
                    Texture2D button_on_hover = LightTexture(button_on, 1.2f);
                    lazorSkin.button.border = new RectOffset(5, 5, 5, 5);
                    lazorSkin.button.normal.background = button; 
                    lazorSkin.button.hover.background = button_hover; //mouseover
                    lazorSkin.button.active.background = button_on_hover;
                    lazorSkin.button.onNormal.background = button_on; //toggle
                    lazorSkin.button.onHover.background = button_on_hover; //toggle + mouseover
                    lazorSkin.button.onActive.background = button_on_hover;
                    lazorSkin.button.normal.textColor = lazorSkin.button.focused.textColor = Color.white;
                    lazorSkin.button.hover.textColor = lazorSkin.button.active.textColor = Color.yellow;
                    lazorSkin.button.onNormal.textColor = lazorSkin.button.onFocused.textColor = lazorSkin.button.onHover.textColor = lazorSkin.button.onActive.textColor = Color.green;
                    lazorSkin.button.alignment = TextAnchor.MiddleCenter;
                    lazorSkin.button.padding = new RectOffset(2, 2, 2, 2);
                    lazorSkin.button.margin = new RectOffset(1, 1, 1, 1);
                    lazorSkin.button.fontSize = 11;


                    Texture2D toggle = LoadTexture(20, 20, "gui_button_mini_toggle.png");
                    Texture2D toggle_hover = LightTexture(toggle, 1.2f);
                    Texture2D toggle_on = LoadTexture(20, 20, "gui_button_mini_toggle_on.png");
                    Texture2D toggle_on_hover = LightTexture(toggle_on, 1.2f);
                    lazorSkin.toggle.border = new RectOffset(20, 0, 20, 0);
                    lazorSkin.toggle.padding = new RectOffset(20, 0, 3, 0);
                    lazorSkin.toggle.margin = new RectOffset(0, 0, 0, 0);
                    lazorSkin.toggle.overflow = new RectOffset(0, 0, 0, 0);
                    lazorSkin.toggle.normal.background = toggle;
                    lazorSkin.toggle.hover.background = toggle_hover; //mouseover
                    lazorSkin.toggle.active.background = toggle_hover;
                    lazorSkin.toggle.onNormal.background = toggle_on; //toggle
                    lazorSkin.toggle.onHover.background = toggle_on_hover; //toggle + mouseover
                    lazorSkin.toggle.onActive.background = toggle_on_hover;
                    lazorSkin.toggle.fontSize = 11;

                    lazorSkin.label.font = HighLogic.Skin.font;
                    lazorSkin.label.alignment = TextAnchor.MiddleLeft;
                    lazorSkin.label.wordWrap = true;
                    lazorSkin.label.stretchWidth = false;
                    lazorSkin.label.padding = new RectOffset(2, 2, 3, 1);
                    lazorSkin.label.margin = new RectOffset(0, 0, 0, 0);
                    lazorSkin.label.fontSize = 12;
                    lazorSkin.label.normal.textColor = Color.white;
                    //lazorSkin.label.alignment = TextAnchor.MiddleRight;

                    lazorSkin.textField.padding = new RectOffset(1, 1, 1, 1);
                    lazorSkin.textField.margin = new RectOffset(1, 1, 1, 1);
                    lazorSkin.textField.fontSize = 12;
                    lazorSkin.textField.normal.textColor = Color.white;

                    Texture2D slider = LoadTexture(52, 9, "gui_slider_horizontal.png");
                    Texture2D thumb = LoadTexture(12, 13, "gui_slider_horizontal_button.png");
                    Texture2D thumb2 = LoadTexture(12, 13, "gui_slider_horizontal_button_hover.png");
                    lazorSkin.horizontalSlider.normal.background = slider;
                    lazorSkin.horizontalSlider.border = new RectOffset(5, 5, 9, 0);
                    //lazorSkin.horizontalSlider.fixedHeight = 13;

                    lazorSkin.horizontalSliderThumb.normal.background = thumb;
                    lazorSkin.horizontalSliderThumb.hover.background = thumb2;
                    lazorSkin.horizontalSliderThumb.active.background = thumb2;
                    lazorSkin.horizontalSliderThumb.border = new RectOffset(14, 0, 13, 0);
					lazorSkin.horizontalSliderThumb.overflow = new RectOffset(0, 0, 0, -3);

                    lazorSkin.scrollView.margin = new RectOffset(0, 3, 0, 0);
                    lazorSkin.scrollView.padding = new RectOffset(2, 2, 2, 2);
                    lazorSkin.scrollView.overflow = new RectOffset(0, -17, 0, 0);

					lazorSkin.verticalScrollbar.normal.background = LoadTexture(15, 15, "gui_scrollbar_vertical.png");
                    lazorSkin.verticalScrollbar.border = new RectOffset(2, 2, 2, 2);
					lazorSkin.verticalScrollbarThumb.normal.background = LoadTexture(11, 15, "gui_scrollbar_vertical_thumb.png");
                    lazorSkin.verticalScrollbarThumb.border = new RectOffset(2, 2, 2, 2);

                }
                return lazorSkin;
            }
        }

        public static GUIStyle Slider_balance {
            get {
                if (slider_balance == null) {
                    slider_balance = new GUIStyle(GUI.skin.horizontalSlider);
                    Texture2D slider = LoadTexture(190, 24, "gui_slider_h_balance.png");
                    slider_balance.fixedWidth = 190;
                    slider_balance.fixedHeight = 24;
                    slider_balance.normal.background = slider;
                    slider_balance.border = new RectOffset(190, 0, 24, 0);
                    slider_balance.padding = new RectOffset(5, 5, 0, 0);
                    slider_balance.margin = new RectOffset(0, 0, 0, 0);
                    slider_balance.overflow = new RectOffset(0, 0, 0, 0);
                    slider_balance.contentOffset = Vector2.zero;
                    //slider_balance.stretchWidth = false;
                    //slider_balance.stretchHeight = false;
                }
                return slider_balance;
            }
        }

        public static GUIStyle Slider_balance_button {
            get {
                if (slider_balance_button == null) {
                    slider_balance_button = new GUIStyle(GUI.skin.horizontalSliderThumb);
                    Texture2D thumb = LoadTexture(28, 24, "gui_slider_h_balance_button.png");
                    slider_balance_button.fixedWidth = 28;
                    slider_balance_button.fixedHeight = 24;
                    slider_balance_button.normal.background = thumb;
                    slider_balance_button.hover.background = thumb;
                    slider_balance_button.active.background = thumb;
                    //slider_balance_button.border = new RectOffset(3, 25, 23, 1);
                    //slider_balance_button.border = new RectOffset(14, 14, 12, 12);
                    slider_balance_button.border = new RectOffset(0, 0, 0, 0);
                    slider_balance_button.padding = new RectOffset(0, 0, 0, 0);
                    slider_balance_button.margin = new RectOffset(0, 0, 0, 0);
                    slider_balance_button.overflow = new RectOffset(0, 0, 0, 0);
                    //slider_balance_button.contentOffset = Vector2.zero;
                    //slider_balance_button.stretchWidth = false;
                    //slider_balance_button.stretchHeight = false;
                }
                return slider_balance_button;
            }
        }
		
        public static GUIStyle Window_border {
            get {
                if (window_border == null) {
                    window_border = new GUIStyle(GUI.skin.window);
                    Texture2D bg = LoadTexture(64, 64, "gui_window.png");
                    window_border.border = new RectOffset(30, 22, 23, 6);
                    window_border.normal.background = bg;
                    window_border.onNormal.background = bg;
                }
                return window_border;
            }
        }

        public static GUIStyle Window_lazorButton {
            get {
                if (window_lazorButton == null) {
                    window_lazorButton = new GUIStyle(GUI.skin.window);
                    Texture2D bg = LoadTexture(40, 80, "gui_lazorbutton.png");
                    window_lazorButton.border = new RectOffset(40, 0, 80, 0);
                    window_lazorButton.normal.background = bg;
                    window_lazorButton.onNormal.background = bg;
                    window_lazorButton.padding = new RectOffset(0, 0, 0, 0);
                }
                return window_lazorButton;
            }
        }

        public static GUIStyle Button_lazorButton {
            get {
                if (button_lazorButton == null) {
                    button_lazorButton = new GUIStyle();
                    button_lazorButton.margin = new RectOffset(0, 0, 0, 0);
					button_lazorButton.normal.background = LoadTexture(20, 30, "gui_lazorbutton_button.png");
                    button_lazorButton.hover.background = LoadTexture(20, 30, "gui_lazorbutton_button_hover.png");
                }
                return button_lazorButton;
            }
        }
		
        public static GUIStyle Window_eva {
            get {
                if (window_eva == null) {
                    window_eva = new GUIStyle(GUI.skin.window);
                    Texture2D bg = LoadTexture(64, 47, "gui_eva_window.png");
                    window_eva.border = new RectOffset(52, 7, 23, 17);
                    window_eva.normal.background = bg;
                    window_eva.onNormal.background = bg;
                    window_eva.padding = new RectOffset(0, 4, 23, 16);
                }
                return window_eva;
            }
        }

        public static GUIStyle Window_eva_mini {
            get {
                if (window_eva_mini == null) {
                    window_eva_mini = new GUIStyle(GUI.skin.window);
                    Texture2D bg = LoadTexture(64, 34, "gui_eva_window_mini.png");
                    window_eva_mini.border = new RectOffset(52, 7, 33, 1);
                    window_eva_mini.normal.background = bg;
                    window_eva_mini.onNormal.background = bg;
                    window_eva_mini.padding = new RectOffset(0, 10, 23, 0);
                }
                return window_eva_mini;
            }
        }
		
        public static GUIStyle Space_Compact {
            get {
                if (space_compact == null) {
                    space_compact = new GUIStyle();
                    space_compact.padding = new RectOffset(0, 0, 0, 0);
                    space_compact.margin = new RectOffset(0, 0, 0, 0);
                    space_compact.stretchHeight = true;
                    space_compact.stretchWidth = true;
                }
                return space_compact;
            }
        }

        public static GUIStyle Space_Formatted {
            get {
                if (space_formatted == null) {
                    space_formatted = new GUIStyle();
                    space_formatted.padding = new RectOffset(0, 20, 0, 0);
                    space_formatted.margin = new RectOffset(0, 0, 0, 0);
                    space_formatted.stretchHeight = true;
                    space_formatted.stretchWidth = true;
                }
                return space_formatted;
            }
        }

        public static GUIStyle Button_header_minimize {
            get {
                if (button_header_minimize == null) {
                    button_header_minimize = new GUIStyle();
                    button_header_minimize.margin = new RectOffset(0, 0, 0, 0);
                    Texture2D button = LoadTexture(20, 20, "gui_button_minimize.png");
                    button_header_minimize.normal.background = button;
                    Texture2D button_on = LoadTexture(20, 20, "gui_button_minimize_on.png");
                    button_header_minimize.hover.background = button_on;
                }
                return button_header_minimize;
            }
        }

        public static GUIStyle Button_header_close {
            get {
                if (button_header_close == null) {
                    button_header_close = new GUIStyle();
                    button_header_close.margin = new RectOffset(0, 0, 0, 0);
                    Texture2D button = LoadTexture(20, 20, "gui_button_close.png");
                    button_header_close.normal.background = button;
                    Texture2D button_on = LoadTexture(20, 20, "gui_button_close_on.png");
                    button_header_close.hover.background = button_on;
                }
                return button_header_close;
            }
        }

        public static GUIStyle Button_color_white {
            get {
                if (button_color_white == null) {
                    button_color_white = GetColorButton("gui_button_color_white.png");
                }
                return button_color_white;
            }
        }

        public static GUIStyle Button_color_red {
            get {
                if (button_color_red == null) {
                    button_color_red = GetColorButton("gui_button_color_red.png");
                }
                return button_color_red;
            }
        }

        public static GUIStyle Button_color_green {
            get {
                if (button_color_green == null) {
                    button_color_green = GetColorButton("gui_button_color_green.png");
                }
                return button_color_green;
            }
        }

        public static GUIStyle Button_color_blue {
            get {
                if (button_color_blue == null) {
                    button_color_blue = GetColorButton("gui_button_color_blue.png");
                }
                return button_color_blue;
            }
        }

        public static GUIStyle Button_color_yellow {
            get {
                if (button_color_yellow == null) {
                    button_color_yellow = GetColorButton("gui_button_color_yellow.png");
                }
                return button_color_yellow;
            }
        }

        public static GUIStyle Button_color_magenta {
            get {
                if (button_color_magenta == null) {
                    button_color_magenta = GetColorButton("gui_button_color_magenta.png");
                }
                return button_color_magenta;
            }
        }

        // Button_color helper function
        private static GUIStyle GetColorButton(string file) {
            GUIStyle style = new GUIStyle();
            style.margin = new RectOffset(0, 0, 0, 0);
            Texture2D button = LoadTexture(20, 20, file);
            style.normal.background = button;
            style.border = new RectOffset(3, 3, 2, 2);
            return style;
        }

        public static GUIStyle Button_bold {
            get {
                if (button_bold == null) {
                    button_bold = new GUIStyle(GUI.skin.button);
                    button_bold.fontSize = 12;
                    button_bold.fontStyle = FontStyle.Bold;
                }
                return button_bold;
            }
        }
		
        //button next to floating buttons
        public static GUIStyle Button_floatingToggle {
            get {
                if (button_floatingToggle == null) {
                    button_floatingToggle = new GUIStyle(GUI.skin.button);
                    button_floatingToggle.fontSize = 12;
                    button_floatingToggle.padding = new RectOffset(0, 0, 0, 0);
                    button_floatingToggle.margin = new RectOffset(0, 0, 0, 0);
                    button_floatingToggle.contentOffset = new Vector2(-1, 0);
                }
                return button_floatingToggle;
            }
        }

        public static GUIStyle Divider {
            get {
                if (divider == null) {
                    divider = new GUIStyle();
                    divider.margin = new RectOffset(0, 0, 0, 0);
                    divider.padding = new RectOffset(0, 2, 2, 2);
                    Texture2D bg = LoadTexture(45, 24, "gui_divider.png");
                    divider.normal.background = bg;
                    divider.border = new RectOffset(29, 3, 2, 4);
                }
                return divider;
            }
        }
		
        public static GUIStyle Divider_gray {
            get {
                if (divider_gray == null) {
                    divider_gray = new GUIStyle();
                    divider_gray.margin = new RectOffset(0, 0, 0, 0);
                    divider_gray.padding = new RectOffset(0, 0, 1, 3);
                    Texture2D bg = LoadTexture(45, 24, "gui_divider_gray.png");
                    divider_gray.normal.background = bg;
                    divider_gray.border = new RectOffset(29, 3, 2, 4);
                }
                return divider_gray;
            }
        }
		
        public static GUIStyle Divider_gray_button {
            get {
                if (divider_gray_button == null) {
                    divider_gray_button = new GUIStyle();
                    divider_gray_button.margin = new RectOffset(0, 0, 0, 0);
                    Texture2D button = LoadTexture(20, 20, "gui_divider_gray_button.png");
                    divider_gray_button.normal.background = button;
                    Texture2D button_on = LoadTexture(20, 20, "gui_divider_gray_button_hover.png");
                    divider_gray_button.hover.background = button_on;
                }
                return divider_gray_button;
            }
        }
		
        public static GUIStyle Divider_directions_arrowBG {
            get {
                if (divider_directions_arrowBG == null) {
                    divider_directions_arrowBG = new GUIStyle();
                    divider_directions_arrowBG.margin = new RectOffset(0, 0, 0, 0);
                    divider_directions_arrowBG.padding = new RectOffset(2, 2, 2, 2);
                    Texture2D bg = LoadTexture(76, 75, "gui_divider_directions_arrowbg.png");
                    divider_directions_arrowBG.normal.background = bg;
                }
                return divider_directions_arrowBG;
            }
        }
		
        public static GUIStyle Divider_directions_BG {
            get {
                if (divider_directions_BG == null) {
                    divider_directions_BG = new GUIStyle();
                    divider_directions_BG.margin = new RectOffset(0, 0, 0, 0);
                    divider_directions_BG.padding = new RectOffset(0, 2, 1, 3);  //new RectOffset(0, 2, 3, 7);
                    Texture2D bg = LoadTexture(76, 75, "gui_divider_directions_bg.png");
                    divider_directions_BG.normal.background = bg;
                    divider_directions_BG.border = new RectOffset(8, 1, 8, 10);
                }
                return divider_directions_BG;
            }
        }

        public static GUIStyle Parameters_highlight {
            get {
                if (parameters_highlight == null) {
                    parameters_highlight = new GUIStyle();
                    parameters_highlight.padding = new RectOffset(0, 0, 0, 0);
                    parameters_highlight.margin = new RectOffset(0, 0, 1, 1);
                    parameters_highlight.normal.background = getTexture(new Color(0.2f, 0.2f, 0.2f, 0.9f));
                    parameters_highlight.hover.background = parameters_highlight.normal.background;
                    parameters_highlight.onHover.background = parameters_highlight.normal.background;
                    parameters_highlight.stretchHeight = true;
                    parameters_highlight.stretchWidth = true;
                }
                return parameters_highlight;
            }
        }
		
        public static GUIStyle Parameters_normal {
            get {
                if (parameters_normal == null) {
                    parameters_normal = new GUIStyle();
                    parameters_normal.padding = new RectOffset(0, 0, 0, 0);
                    parameters_normal.margin = new RectOffset(0, 0, 1, 1);
                    parameters_normal.normal.background = getTexture(new Color(0.1f, 0.1f, 0.1f, 0.9f));
                    parameters_normal.hover.background = parameters_normal.normal.background;
                    parameters_normal.onHover.background = parameters_normal.normal.background;
                    parameters_normal.stretchHeight = false;
                    parameters_normal.stretchWidth = true;
                }
                return parameters_normal;
            }
        }

        public static GUIStyle TxtArea {
            get {
                if (txtArea == null) {
                    txtArea = new GUIStyle();
                    Texture2D bg = LightTexture(LoadTexture(32, 32, "gui_button_on.png"), 0.5f);
                    txtArea.normal.background = bg;
                    txtArea.padding = new RectOffset(2, 2, 2, 2);
                    txtArea.border = new RectOffset(5, 5, 5, 5);
                    txtArea.hover.background = txtArea.normal.background;
                    txtArea.onHover.background = txtArea.normal.background;
                    txtArea.stretchHeight = true;
                    txtArea.stretchWidth = true;
                }
                return txtArea;
            }
        }
		
        public static GUIStyle LabelBold {
            get {
                if (labelBold == null) {
                    labelBold = new GUIStyle(GUI.skin.label);
                    labelBold.fontStyle = FontStyle.Bold;
                }
                return labelBold;
            }
        }

        public static GUIStyle Buttons_arrows_mainPanel {
            get {
                if (buttons_arrows_mainPanel == null) {
                    buttons_arrows_mainPanel = new GUIStyle(GUI.skin.button);
                    buttons_arrows_mainPanel.normal.textColor = buttons_arrows_mainPanel.focused.textColor = Color.white;
                    buttons_arrows_mainPanel.hover.textColor = buttons_arrows_mainPanel.active.textColor = Color.yellow;
                    buttons_arrows_mainPanel.onNormal.textColor = buttons_arrows_mainPanel.onFocused.textColor = buttons_arrows_mainPanel.onHover.textColor = buttons_arrows_mainPanel.onActive.textColor = Color.green;
                    buttons_arrows_mainPanel.padding = new RectOffset(0, 3, 4, 4);
                    buttons_arrows_mainPanel.margin = new RectOffset(2, 2, 2, 2);
                    buttons_arrows_mainPanel.fontSize = 11;
                    buttons_arrows_mainPanel.alignment = TextAnchor.MiddleCenter;
                }
                return buttons_arrows_mainPanel;
            }
        }

        public static GUIStyle Button_Toggle { //force solid buttons on toggle
            get {
                if (button_toggle == null) {
                    button_toggle = new GUIStyle(GUI.skin.button);
                }
                return button_toggle;
            }
        }

		public static GUIStyle ListItem_std{
			get {
				if (listItem_std == null) {
					listItem_std = new GUIStyle(GUI.skin.label);
					listItem_std.padding = new RectOffset(2, 1, 1, 1);
					listItem_std.margin = new RectOffset(1, 1, 1, 1);
					listItem_std.fontSize = 12;
					listItem_std.normal.textColor = Color.white;
					listItem_std.hover.textColor = Color.white;
					Texture2D textureHover = getTexture(Color.yellow);
					listItem_std.hover.background = textureHover;
					listItem_std.onHover.background = textureHover;
					listItem_std.stretchWidth = true;
					listItem_std.alignment = TextAnchor.MiddleLeft;
				}
				return listItem_std;
			}
		}

		public static GUIStyle ListItemBG_compact {
			get {
				if (listItemBG_compact == null) {
					listItemBG_compact = new GUIStyle(Space_Compact);
					listItemBG_compact.padding = new RectOffset(1, 0, 0, 0);
					listItemBG_compact.margin = new RectOffset(1, 1, 1, 1);
					Texture2D texture = getTexture(new Color(0.1f, 0.1f, 0.1f, 0.9f));
					listItemBG_compact.normal.background = texture;
				}
				return listItemBG_compact;
			}
		}





        //CUSTOM GUISTYLES......................................................................................................................................

        public static GUIStyle StdLabelSmallCustom_Compact(Color c) {
            if (stdLabelSmallCustom_compact == null) {
                stdLabelSmallCustom_compact = new GUIStyle(GUI.skin.label);
                stdLabelSmallCustom_compact.fontSize = 12;
                stdLabelSmallCustom_compact.padding = new RectOffset(1, 1, 1, 0);
            }
            stdLabelSmallCustom_compact.alignment = TextAnchor.MiddleRight;
            stdLabelSmallCustom_compact.normal.textColor = c;
            return stdLabelSmallCustom_compact;
        }

        public static GUIStyle StdLabelSmallCustom(Color c) {
            if (stdLabelSmallCustom == null) {
                stdLabelSmallCustom = new GUIStyle(GUI.skin.label);
                stdLabelSmallCustom.fontSize = 12;
            }
            stdLabelSmallCustom.alignment = TextAnchor.MiddleRight;
            stdLabelSmallCustom.normal.textColor = c;
            return stdLabelSmallCustom;
        }

        public static GUIStyle StdLabelSmallCustom(Color c, TextAnchor alignment) {
            if (stdLabelSmallCustom == null) {
                stdLabelSmallCustom = new GUIStyle(GUI.skin.label);
                stdLabelSmallCustom.fontSize = 12;
            }
            stdLabelSmallCustom.alignment = alignment;
            stdLabelSmallCustom.normal.textColor = c;
            return stdLabelSmallCustom;
        }

        public static GUIStyle Label(int textSize, Color textColor, Color textColorHover, Color bgColor) {
            if (label == null) {
                label = new GUIStyle(GUI.skin.label);
                label.padding = new RectOffset(1, 1, 1, 1);
                label.margin = new RectOffset(1, 1, 1, 1);
                label.stretchWidth = false;
                label.alignment = TextAnchor.MiddleLeft;
            }
            label.fontSize = textSize;
            label.normal.textColor = textColor;
            label.hover.textColor = textColorHover;
            labelTexture = getTexture(bgColor);
            label.normal.background = labelTexture;
            label.hover.background = labelTexture;
            label.onHover.background = labelTexture;
            return new GUIStyle(label);
        }

        public static GUIStyle CrosshairLabel(Color c) {
            if (crosshairLabel == null) {
                crosshairLabel = new GUIStyle(GUI.skin.label);
                crosshairLabel.fontSize = 9;
                crosshairLabel.alignment = TextAnchor.LowerLeft;
            }
            crosshairLabel.normal.textColor = c;
            return crosshairLabel;
        }







       






        //LOADING / SAVING.......................................................................................................................



        public static Texture2D LightTexture(Texture2D texture, float v) {
            Texture2D newTexture = new Texture2D(texture.width, texture.height, TextureFormat.ARGB32, false);
            for (int i = 0; i < 32; i++) {
                for (int j = 0; j < 32; j++) {
                    Color c = texture.GetPixel(i, j);
                    newTexture.SetPixel(i, j, new Color(c.r * v, c.g * v, c.b * v, c.a));
                }
            } newTexture.Apply();
            return newTexture;
        }

        public static Texture2D LoadTexture(int w, int h, string file) {
            /*Texture2D texture = new Texture2D(w, h, TextureFormat.ARGB32, false);
			WWW www = new WWW("file://" + KSPUtil.ApplicationRootPath.Replace("\\", "/").Replace("KSP_Data/../","") + "PluginData/romfarer/textures/" + file);
			//MonoBehaviour.print("LZZ "+www.url);
            www.LoadImageIntoTexture(texture);
            return texture;*/
			/*Texture2D tex = GameDatabase.Instance.GetTexture ("Romfarer/textures/"+file.Replace(".png",""), false);
			tex.filterMode = FilterMode.Bilinear;
			return tex;*/
		
			return GameDatabase.Instance.GetTexture (RuntimeLogic.ApplicationPath + "textures/"+file.Replace(".png",""), false);
        }


        public static void Load(string file, ref Dictionary<string, KSPParseable> data) { //load achievement list
            if (!File.Exists<Config>(file)) {
                MonoBehaviour.print("Romfarer Lazor System: No config file found, saving default.");
                Save(file, data);
            } else {
                try {
                    //MonoBehaviour.print("xxx load");
                    TextReader tr = TextReader.CreateForType<Config>(file);
                    while (tr.Peek() != -1) {
                        string l = tr.ReadLine();
                        string[] item = l.Replace(" ","").Split(new char[]{':'});
                        if (data.ContainsKey(item[0])) {
                            //MonoBehaviour.print("xxx loading containsdata");
                            if (data[item[0]].type == KSPParseable.Type.BOOL)
                                data[item[0]] = new KSPParseable(bool.Parse(item[1]), KSPParseable.Type.BOOL);
							else if (data[item[0]].type == KSPParseable.Type.STRING)
								data[item[0]] = new KSPParseable(item[1], KSPParseable.Type.STRING);
							else if (data[item[0]].type == KSPParseable.Type.INT)
								data[item[0]] = new KSPParseable(item[1], KSPParseable.Type.INT);
                                //MonoBehaviour.print("xxx loading "+ bool.Parse(item[1]).ToString());
                            
                        }
                    }
                    tr.Close();
                    tr.Dispose();
                } catch (IOException) { } catch (Exception) { }
            }
        }
        public static void Save(string file, Dictionary<string, KSPParseable> data) {
            try {
                //MonoBehaviour.print("xxx save");
                TextWriter tw = TextWriter.CreateForType<GUIachievements>(file);
                foreach (string s in data.Keys) {
                    if (data[s].type == KSPParseable.Type.BOOL)
                        tw.WriteLine(s + " : " + data[s].value_bool.ToString());
					else if (data[s].type == KSPParseable.Type.STRING)
						tw.WriteLine(s + " : " + data[s].value);
					else if (data[s].type == KSPParseable.Type.INT)
						tw.WriteLine(s + " : " + data[s].value_int.ToString());
                }
                tw.Flush();
                tw.Close();
                tw.Dispose();
            } catch (IOException) { } catch (Exception) { }
        }








        //KSPParseable.....................



        public static void SaveKSPParseableRect(Dictionary<string, KSPParseable> partDataCollection, string i, Rect r){
            partDataCollection.Add(i + "_X", new KSPParseable(r.x, KSPParseable.Type.FLOAT));
            partDataCollection.Add(i + "_Y", new KSPParseable(r.y, KSPParseable.Type.FLOAT));
        }

        public static void LoadKSPParseableRect(Dictionary<string, KSPParseable> parsedData, string i, ref Rect r) {
            if (parsedData.ContainsKey(i+"_X"))
                r.x = parsedData[i + "_X"].value_float;
            if (parsedData.ContainsKey(i + "_Y"))
                r.y = parsedData[i + "_Y"].value_float;
        }

		public static string DictionaryToString(Dictionary<string, string> d){
			string rs = "";
			foreach(string s in d.Keys) {
				rs += s.Replace(" ", "_")+"#"+d[s]+"#";
			}
			return rs;
		}

		public static Dictionary<string, string> StringToDictionary(string s){
			Dictionary<string, string> d = new Dictionary<string, string>();
			string[] item = s.Replace("_"," ").Split(new char[]{'#'});
			//MonoBehaviour.print("ABCD len "+item.Length);
			for(int i = 0; i<item.Length-1; i+=2){
				//MonoBehaviour.print("StringToDictionary "+item[i] + "   "+ item[i+1]);
				d.Add(item[i], item[i+1]);
			}
			return d;
		}

		//merge string dictionaries
		public static Dictionary<string, string> MergeStringDictionary(Dictionary<string, string> a, Dictionary<string, string> b){
			Dictionary<string, string> d = new Dictionary<string, string> (a);
			foreach (KeyValuePair<string, string> pair in b)
				if (!d.ContainsKey(pair.Key))
					d.Add (pair.Key, pair.Value);

			return d;
		}



        //String stuff............................




        public static Color StringToColor(string s) {
            switch (s) {
                case "green":
                    return Color.green;
                case "blue":
                    return Color.blue;
                case "red":
                    return Color.red;
                case "yellow":
                    return Color.yellow;
                case "magenta":
                    return Color.magenta;
            }
            return Color.white;
        }

        public static string ColorToString(Color c) {
            if(c == Color.green)
                return "green";
            else if(c == Color.blue)
                return "blue";
            else if(c == Color.red)
                return "red";
            else if(c == Color.yellow)
                return "yellow";
            else if (c==Color.magenta)
                return "magenta";
            return "white";
        }







		
		
		//Textures.......................................................................................................................




        public static Texture2D PlanetTexture {
            get {
                if (planetTexture == null) {
                    Color white = new Color(1.0f, 1.0f, 1.0f, 0.5f);
                    Color eq = new Color(0.0f, 1.0f, 0.0f, 0.6f);
                    Color n = new Color(1f, 0.486274f, 0.231372f, 0.6f);
                    planetTexture = new Texture2D(2048, 1024, TextureFormat.ARGB32, false);
                    for (int x = 0; x < planetTexture.width; x++)
                        for (int y = 0; y < planetTexture.height; y++)
                            planetTexture.SetPixel(x, y, Color.clear);

                    for (int y = 0; y < planetTexture.width; y ++) // longitude 0
                        planetTexture.SetPixel(0, y, n);

                    for (int x = 1; x < 36; x ++) //longitudes
                        for (int y = 0; y < planetTexture.height; y++)
                            planetTexture.SetPixel(x * planetTexture.width / 36, y, white);

                    for (int x = 0; x < planetTexture.width; x++) // latitude 0, equator
                        planetTexture.SetPixel(x, 512, eq);

                    for (int x = 0; x < planetTexture.width; x++) // latitude -90, south pole
                        planetTexture.SetPixel(x, 1, Color.red);
                    for (int x = 0; x < planetTexture.width; x++) // latitude 90, north pole
                        planetTexture.SetPixel(x, 1022, Color.red);

                    for (int y = 1; y < 18; y++)
                        if(y != 9)
                            for (int x = 0; x < planetTexture.width; x++) //longitudes
                                planetTexture.SetPixel(x, y * planetTexture.height / 18, white);
                    planetTexture.Apply();
                }
                return planetTexture;
            }
        }




        public static Texture2D crossHairTarget {
            get {
                Texture2D tex = new Texture2D(50, 50);
                for (int x = 0; x < 50; x++) {
                    for (int y = 0; y < 50; y++) {
                        if (x == 0 && (y < 10 || y > 39)
                            || x == 1 && (y < 10 || y > 39)
                            || y == 0 && (x < 10 || x > 39)
                            || y == 1 && (x < 10 || x > 39)
                            || x == 48 && (y < 10 || y > 39)
                            || x == 49 && (y < 10 || y > 39)
                            || y == 48 && (x < 10 || x > 39)
                            || y == 49 && (x < 10 || x > 39))
                            tex.SetPixel(x, y, Color.red);
                        else
                            tex.SetPixel(x, y, Color.clear);
                    }
                }
                tex.Apply();
                return tex;
            }
        }

        public static Texture2D crossHairTracker {
            get {
                Texture2D tex = new Texture2D(50, 50);
                for (int x = 0; x < 50; x++) {
                    for (int y = 0; y < 50; y++) {
                        if (x == 0 && y > 9 && y < 40
                            || y == 0 && x > 9 && x < 40
                            || x == 49 && y > 9 && y < 40
                            || y == 49 && x > 9 && x < 40)
                            tex.SetPixel(x, y, new Color(1, 0, 0, 0.7f));
                        else
                            tex.SetPixel(x, y, Color.clear);
                    }
                }
                tex.Apply();
                return tex;
            }
        }

        public static Texture2D crossHairAim {
            get {
                Texture2D tex = new Texture2D(40, 40);
                for (int x = 0; x < 40; x++) {
                    for (int y = 0; y < 40; y++) {
                        if (x == 19 && (y > 25 || y < 14)
                            || x == 20 && (y > 25 || y < 14)
                            || y == 19 && (x > 25 || x < 14)
                            || y == 20 && (x > 25 || x < 14))
                            tex.SetPixel(x, y, new Color(1, 0, 0, 0.7f));
                        else
                            tex.SetPixel(x, y, Color.clear);
                    }
                }
                tex.Apply();
                return tex;
            }
        }

        public static Texture2D crossHairAimGreen {
            get {
                Texture2D tex = new Texture2D(41, 41);
                for (int x = 0; x < 41; x++) {
                    for (int y = 0; y < 41; y++) {
                        tex.SetPixel(x, y, Color.clear);
                    }
                }
                for (int z = 0; z < 360; z++) {
                    tex.SetPixel(Mathf.FloorToInt(20 + 20 * Mathf.Cos(z * Mathf.Deg2Rad)), Mathf.FloorToInt(20 + 20 * Mathf.Sin(z * Mathf.Deg2Rad)), new Color(0, 1, 0, 0.1f));
                    tex.SetPixel(Mathf.FloorToInt(20 + 16 * Mathf.Cos(z * Mathf.Deg2Rad)), Mathf.FloorToInt(20 + 16 * Mathf.Sin(z * Mathf.Deg2Rad)), new Color(0, 1, 0, 0.3f));
                    tex.SetPixel(Mathf.FloorToInt(20 + 12 * Mathf.Cos(z * Mathf.Deg2Rad)), Mathf.FloorToInt(20 + 12 * Mathf.Sin(z * Mathf.Deg2Rad)), new Color(0, 1, 0, 0.5f));
                    tex.SetPixel(Mathf.FloorToInt(20 + 8 * Mathf.Cos(z * Mathf.Deg2Rad)), Mathf.FloorToInt(20 + 8 * Mathf.Sin(z * Mathf.Deg2Rad)), new Color(0, 1, 0, 0.7f));
                    tex.SetPixel(Mathf.FloorToInt(20 + 4 * Mathf.Cos(z * Mathf.Deg2Rad)), Mathf.FloorToInt(20 + 4 * Mathf.Sin(z * Mathf.Deg2Rad)), new Color(0, 1, 0, 0.9f));
                }
                tex.Apply();
                return tex;
            }
        }

        public static Texture2D crossHairAimBlue {
            get {
                Texture2D tex = new Texture2D(41, 41);
                for (int x = 0; x < 41; x++) {
                    for (int y = 0; y < 41; y++) {
                        if ((x == y || x - 1 == y || 40 - x == y || 40 - x-1 == y) && (x > 25 || x < 15) && (y > 25 || y < 15))
                            tex.SetPixel(x, y, new Color(0, 0, 1, 0.7f));
                        else
                            tex.SetPixel(x, y, Color.clear);
                    }
                }
                for (int z = 0; z < 360; z++) {
                    tex.SetPixel(Mathf.FloorToInt(20 + 9 * Mathf.Cos(z * Mathf.Deg2Rad)), Mathf.FloorToInt(20 + 9 * Mathf.Sin(z * Mathf.Deg2Rad)), new Color(0, 0, 1, 0.5f));
                    tex.SetPixel(Mathf.FloorToInt(20 + 8 * Mathf.Cos(z * Mathf.Deg2Rad)), Mathf.FloorToInt(20 + 8 * Mathf.Sin(z * Mathf.Deg2Rad)), new Color(0, 0, 1, 0.7f));
                }
                tex.Apply();
                return tex;
            }
        }

        public static Texture2D crossHairAimBlueConnection {
            get {
                Texture2D tex = crossHairAimBlue;
                for (int z = 0; z < 360; z++) {
                    for(int i = 0; i < 8;i++){
                        tex.SetPixel(Mathf.FloorToInt(20 + i * Mathf.Cos(z * Mathf.Deg2Rad)), Mathf.FloorToInt(20 + i * Mathf.Sin(z * Mathf.Deg2Rad)), new Color(0, 1, 0, 0.7f));
                    }
                }
                tex.Apply();
                return tex;
            }
        }

        public static Texture2D crossHairTargetBlueConnection {
            get {
                Texture2D tex = new Texture2D(51, 51);
                for (int x = 0; x < 51; x++) {
                    for (int y = 0; y < 51; y++) {
                        tex.SetPixel(x, y, Color.clear);
                    }
                }
                for (int z = 0; z < 360; z++) {
                    tex.SetPixel(Mathf.FloorToInt(25 + 9 * Mathf.Cos(z * Mathf.Deg2Rad)), Mathf.FloorToInt(25 + 9 * Mathf.Sin(z * Mathf.Deg2Rad)), new Color(0, 0, 1, 0.5f));
                    tex.SetPixel(Mathf.FloorToInt(25 + 8 * Mathf.Cos(z * Mathf.Deg2Rad)), Mathf.FloorToInt(25 + 8 * Mathf.Sin(z * Mathf.Deg2Rad)), new Color(0, 0, 1, 0.7f));
                }
                for (int z = 0; z < 360; z++) {
                    for (int i = 0; i < 8; i++) {
                        tex.SetPixel(Mathf.FloorToInt(25 + i * Mathf.Cos(z * Mathf.Deg2Rad)), Mathf.FloorToInt(25 + i * Mathf.Sin(z * Mathf.Deg2Rad)), new Color(0, 1, 0, 0.7f));
                    }
                }
                for (int x = 0; x < 51; x++) {
                    for (int y = 0; y < 51; y++) {
                        if (x == 0 && (y < 10 || y > 40)
                            || x == 1 && (y < 10 || y > 40)
                            || y == 0 && (x < 10 || x > 40)
                            || y == 1 && (x < 10 || x > 40)
                            || x == 49 && (y < 10 || y > 40)
                            || x == 50 && (y < 10 || y > 40)
                            || y == 49 && (x < 10 || x > 40)
                            || y == 50 && (x < 10 || x > 40))
                            tex.SetPixel(x, y, new Color(0, 0, 1, 0.7f));
                    }
                }
                tex.Apply();
                return tex;
            }
        }

        public static Texture2D crossHairAimWhite {
            get {
                Texture2D tex = new Texture2D(41, 41);
                for (int x = 0; x < 41; x++) {
                    for (int y = 0; y < 41; y++) {
                        tex.SetPixel(x, y, Color.clear);
                    }
                }
                for (int z = 0; z < 360; z++) {
                    tex.SetPixel(Mathf.FloorToInt(20 + 13 * Mathf.Cos(z * Mathf.Deg2Rad)), Mathf.FloorToInt(20 + 13 * Mathf.Sin(z * Mathf.Deg2Rad)), new Color(1, 1, 1, 0.5f));
                    tex.SetPixel(Mathf.FloorToInt(20 + 12 * Mathf.Cos(z * Mathf.Deg2Rad)), Mathf.FloorToInt(20 + 12 * Mathf.Sin(z * Mathf.Deg2Rad)), new Color(1, 1, 1, 0.7f));
                }
                for (int x = 0; x < 41; x++) {
                    for (int y = 0; y < 41; y++) {
                        if (x < 24 && x > 16 || y < 24 && y > 16) {
                            tex.SetPixel(x, y, Color.clear);
                        }
                    }
                }
                tex.SetPixel(20, 20, new Color(1, 1, 1, 0.7f));
                tex.Apply();
                return tex;
            }
        }

        public static Texture2D GetCrossHairHitPoint(Color c) {
            Texture2D tex = new Texture2D(11, 11);
            tex.filterMode = FilterMode.Trilinear;
            for (int x = 0; x < 11; x++) {
                for (int y = 0; y < 11; y++) {
                    tex.SetPixel(x, y, Color.clear);
                }
            }
            /*for (int z = 0; z < 360; z++) {
                int x = Mathf.FloorToInt(5 + 3.5f * Mathf.Cos(z * Mathf.Deg2Rad));
                int y = Mathf.FloorToInt(5 + 3.5f * Mathf.Sin(z * Mathf.Deg2Rad));
                tex.SetPixel(x, y, new Color(c.r, c.g, c.b, 0.2f));
                x = Mathf.FloorToInt(5 + 4.5f * Mathf.Cos(z * Mathf.Deg2Rad));
                y = Mathf.FloorToInt(5 + 4.5f * Mathf.Sin(z * Mathf.Deg2Rad));
                tex.SetPixel(x, y, new Color(c.r, c.g, c.b, 0.2f));
            }*/
            float cf = 0;
            for (int z = 0; z < 360; z++) {
                int x = Mathf.FloorToInt(5 + 3.9f * Mathf.Cos(z * Mathf.Deg2Rad));
                int y = Mathf.FloorToInt(5 + 3.9f * Mathf.Sin(z * Mathf.Deg2Rad));
                cf = 0.6f + tex.GetPixel(x, y).a;
                tex.SetPixel(x, y, new Color(c.r, c.g, c.b, cf));
            }
            //tex.SetPixel(5, 5, c);
            tex.Apply();
            return tex;
        }

        //prone to memory-leak DO NOT call it more than you have to.
        public static Texture2D getTexture(Color c) {
            Texture2D texture = new Texture2D(2, 2);
            Color[] colors = new Color[4];
            for (int i = 0; i < 4; i++)
                colors[i] = c;
            texture.SetPixels(colors);
            texture.Apply();
            return texture;
        }

        



        // Misc.................................................................................................................................

        public static List<Part> GetAllChildren(Part p) {
            if(childList==null)
                childList = new List<Part>();
            else
                childList.Clear();
            DeptFirstParts(p);
            return childList;
        }

        private static Part DeptFirstParts(Part p) {
            if (p.children != null || p.children.Count > 0) {
                foreach (Part q in p.children) {
                    childList.Add(DeptFirstParts(q));
                }
            }
            return p;
        }


        public static string CutString(string s, int l, string add) {
            if (s.Length > l)
                return s.Substring(0, l - add.Length) + add;
            else
                return s;
        }

        public static string SecondsAsTimeString(double secs) {
            if (secs * 10000000 > Int64.MaxValue)
                return "∞";
            timeSpan = new TimeSpan((long)secs*10000000);
            if(timeSpan.Days>0)
                return string.Format("{0}d {1:D2}:{2:D2}:{3:D2}", timeSpan.Days, timeSpan.Hours, timeSpan.Minutes, timeSpan.Seconds);
            else
                return string.Format("{0:D2}:{1:D2}:{2:D2}", timeSpan.Hours, timeSpan.Minutes, timeSpan.Seconds);
        }

        public delegate GUIStyle StyleDelegate(Color c);
        public static void DistanceFormatted(double d, string name, StyleDelegate style, Color c1, Color c2) {
            string distance = d.ToString("f1");
            string unit = "m";
            if (d > 1000000) {
                distance = (d / 1000000).ToString("f3");
                unit = "Mm";
            } else if (d > 10000) {
                distance = (d / 1000).ToString("f3");
                unit = "km";
            }
            GUILayout.Label(name, style(c1));
            GUILayout.Label(distance, style(c2));
            GUILayout.Label(unit, style(c1));
        }

        public static void DistanceFormatted(double d, Color c, string name) {
            string distance = d.ToString("f1");
            string unit = "m";
            if (d > 1000000) {
                distance = (d / 1000000).ToString("f3");
                unit = "Mm";
            } else if (d > 10000) {
                distance = (d / 1000).ToString("f3");
                unit = "km";
            }
            GUILayout.Label(name, Util.StdLabelSmallCustom(c));
            GUILayout.Label(distance, Util.StdLabelSmallCustom(Color.white));
            GUILayout.Label(unit, Util.StdLabelSmallCustom(c));
        }

        public static void DegToSexFormatted(double d, Color c) {
            double deg, min, sec;
            DegToSex(d, out deg, out min, out sec);
            GUILayout.Label(deg.ToString("f0"), Util.StdLabelSmallCustom(Color.white));
            GUILayout.Label("° ", Util.StdLabelSmallCustom(c));
            GUILayout.Label(min.ToString("f0"), Util.StdLabelSmallCustom(Color.white));
            GUILayout.Label("' ", Util.StdLabelSmallCustom(c));
            GUILayout.Label(((int)Math.Floor(sec)).ToString("f0"), Util.StdLabelSmallCustom(Color.white));
            GUILayout.Label("\"", Util.StdLabelSmallCustom(c));
        }

        public static string DegToSex(double d) {
            double deg, min, sec;
            DegToSex(d, out deg, out min, out sec);
            return deg+"° "+min+"' "+ (int)Math.Floor(sec)+"\"";
        }

        public static void DegToSex(double d, out double deg, out double min, out double sec) {
            deg = Math.Floor(Math.Abs(d));
            min = Math.Floor(60 * (Math.Abs(d) - deg));
            sec = 3600 * (Math.Abs(d) - deg - min / 60);
        }

        public static double SexToDeg(double deg, double min, double sec) {
            return (((sec / 60) + min) / 60) + deg;
        }

        public static double GreatCircleBearing(double sLat, double sLon, double fLat, double fLon) {
            double fLatx = fLat * Mathf.Deg2Rad;
            double sLatx = sLat * Mathf.Deg2Rad;
            double lambda = (fLon - sLon > 180 ? fLon - sLon - 360 : fLon - sLon < -180 ? fLon - sLon + 360 : fLon - sLon) * Mathf.Deg2Rad;
            double alpha = Math.Atan2((Math.Cos(fLatx) * Math.Sin(lambda)), (Math.Cos(sLatx) * Math.Sin(fLatx) - Math.Sin(sLatx) * Math.Cos(fLatx) * Math.Cos(lambda))) * Mathf.Rad2Deg;
            return alpha < 0 ? alpha + 360 : alpha;
        }

        public static double GreatCircleDistance(double sLat, double sLon, double fLat, double fLon, double radius) {
            double fLatx = fLat * Mathf.Deg2Rad;
            double sLatx = sLat * Mathf.Deg2Rad;
            double lambda = (fLon - sLon > 180 ? fLon - sLon - 360 : fLon - sLon < -180 ? fLon - sLon + 360 : fLon - sLon) * Mathf.Deg2Rad;
            double thetaF = Math.Sin(sLatx) * Math.Sin(fLatx) + Math.Cos(sLatx) * Math.Cos(fLatx) * Math.Cos(lambda);
            double theta = Math.Acos(thetaF);
            if (theta > 178 || theta < 2)
                theta = Math.Atan2(Math.Sqrt(Math.Pow(Math.Cos(fLatx) * Math.Sin(lambda), 2) + Math.Pow(Math.Cos(sLatx) * Math.Sin(fLatx) - Math.Sin(sLatx) * Math.Cos(fLatx) * Math.Cos(lambda), 2)), thetaF); 
            return theta * radius;
        }

        public static Vector3d NorthVector(CelestialBody celestialBody, Vector3 position) {
            Vector3d eastUnit = celestialBody.getRFrmVel(position).normalized; //uses the rotation of the body's frame to determine "east"
            Vector3 normal = (position - celestialBody.transform.position).normalized;
            return Vector3d.Cross(eastUnit, normal).normalized; //north = east cross up
        }


        //sets pitch and yaw angle of t in relation to v2
        //returns angle in degrees
        public static void PitchYawAngle(Transform t, Vector3 v2, out float pitch, out float yaw){
            Vector3 a = t.InverseTransformDirection(v2);
            pitch = 90 - Mathf.Atan2(a.y, a.z) * Mathf.Rad2Deg; //pitch
            if (pitch > 180)
                pitch -= 360;
            yaw = Mathf.Atan2(a.x, a.y) * Mathf.Rad2Deg; //yaw
        }

        //in progress
        public static void PitchYawAngle2(Transform t, Vector3 v1, Vector3 v2, out float pitch, out float yaw) {
            Vector3 a = t.InverseTransformDirection(v1+v2); //t.InverseTransformDirection(v2);
            pitch = 90 - Mathf.Atan2(a.y, a.z) * Mathf.Rad2Deg; //pitch
            if (pitch > 180)
                pitch -= 360;
            yaw = Mathf.Atan2(a.x, a.y) * Mathf.Rad2Deg; //yaw
        }
 
        /*
        If A and B are perpendicular (at 90 degrees to each other), the result of the dot product will be zero, because cos(Θ) will be zero.
        If the angle between A and B are less than 90 degrees, the dot product will be positive (greater than zero), as cos(Θ) will be positive, and the vector lengths are always positive values.
        If the angle between A and B are greater than 90 degrees, the dot product will be negative (less than zero), as cos(Θ) will be negative, and the vector lengths are always positive values.
        */

        public static Rect ClampToScreen(Rect r) {
            r.x = Mathf.Clamp(r.x, 0, Screen.width - r.width);
            r.y = Mathf.Clamp(r.y, 0, Screen.height - r.height);
            return r;
        }

        //p = screen position in screen space.
        public static bool IsWithinScreen(Vector3 p) {
            return p.x > 0 && p.x < Screen.width && p.y > 0 && p.y < Screen.height;
        }
        /*public static Vector3 ClampScreenPosition(Vector3 r, Vector3 o) {
            Vector3 rF = Vector3.zero;
            if (r.x < 0 || r.x > Screen.width) {
                rF.x = 
            }
            return r;
        }*/



        //-180 to 180 angle
        public static float AngleSigned(Vector3 v1, Vector3 v2, Vector3 up) {
            if (Vector3.Dot(Vector3.Cross(v1, v2), up) < 0) //greater than 90 i.e v1 left of v2
                return -Vector3.Angle(v1, v2);
            return Vector3.Angle(v1, v2);
        }

        //0 to 360 angle
        public static float Angle(Vector3 v1, Vector3 v2, Vector3 up) {
            if (Vector3.Dot(Vector3.Cross(v1, v2), up) < 0) //greater than 90 i.e v1 left of v2
                return 360 - Vector3.Angle(v1, v2);
            return Vector3.Angle(v1, v2);
        }

        //in degrees
        public static float CalculatePhaseAngle(Vessel vessel, CelestialBody reference, CelestialBody target, Vector3 up) {
            Vector3 b = target.position - reference.position;
            Vector3 a = vessel.transform.position - reference.position;
            return Angle(Vector3.Cross(up, a), Vector3.Cross(up, b), up);
        }

        public static float CalculatePhaseAngle(CelestialBody main, CelestialBody reference, CelestialBody target, Vector3 up) {
            Vector3 b = target.position - reference.position;
            Vector3 a = main.position - reference.position;
            return Angle(Vector3.Cross(up, a), Vector3.Cross(up, b), up);
        }

        //return signed angle in relation to normal's 2d plane
        public static float AngleAroundNormal(Vector3 a, Vector3 b, Vector3 up) {
            return AngleSigned(Vector3.Cross(up, a), Vector3.Cross(up, b), up);
        }

        public static double NormalizeAngle(double a) {
            double b = a - Math.Floor(a / 360) * 360; //modulo for doubles this = a % 360
            return b < 0 ? 360 - b : b;
        }

        //360 to signed angle
        public static float TwoPiToSignedAngle(float a){
            if (a > 180)
                return a - 360;
            return a;
        }

        public static double DoubleMod(double a, double b, out double div) {
            div = Math.Floor(a / b);
            return a - Math.Floor(a / b) * b;
        }


		public static void RotateAroundAxis(Vector3 dir, Vector3 axis, Transform revolver, Transform reference) {
			revolver.localEulerAngles = axis * Util.Angle(-reference.right, Vector3.Cross(dir, reference.up), reference.up);
		}
        /*public static void Revolve(Vector3 dir, Transform revolver, Transform reference) {
            revolver.localEulerAngles = Vector3.up * Util.Angle(-reference.right, Vector3.Cross(dir, reference.up), reference.up);
        }*/
        //Mainly for stacked lazor system
		public static void Revolve2(Vector3 dir, Transform revolver, Transform reference) {
			revolver.localEulerAngles += Vector3.up * Util.AngleSigned(-revolver.right, Vector3.Cross(dir, reference.up), reference.up);
		}

        public static Material GetMaterial(Shader shader, Color color) {
            Material newMaterial = new Material(shader);
            newMaterial.color = color;
            return newMaterial;
        }

        public static void SetMaterial(GameObject go, Material m) {
            MeshRenderer renderer = go.GetComponent<MeshRenderer>();
            renderer.material = m;
        }

        //is the number a and b within offset (in percent) of eachother
        public static bool CloseEnough(double a, double b, double offset) {
            double diff = Math.Abs(a/b);
            return diff > (100 - offset) / 100 && diff < (100 + offset) / 100;
        }

		public static Vector3 MouseLook(Vector2 mousePos, int mask) {
			//Vector2 m = Event.current.mousePosition;
			//MonoBehaviour.print(mousePos);
			RaycastHit hit;
			//Ray ray = Camera.main.ScreenPointToRay(new Vector3(mousePos.x, Screen.height - mousePos.y, 0));
			Ray ray = FlightCamera.fetch.mainCamera.ScreenPointToRay(new Vector3(mousePos.x, Screen.height - mousePos.y, 0));

			//Vector3 endPos = Vector3.zero;
			if (Physics.Raycast(ray.origin, ray.direction, out hit, 20000f, mask))
				return hit.point;
			else
				return ray.GetPoint(20000f);
			//return Vector3.one;
		}

        public static void GUIButton_BeamAboard(LazorSystem system, Vessel target) {
            if (TimeWarp.CurrentRateIndex == 0) { //teleport is disabled at warp
                if (target.rootPart != null && target.rootPart.Modules.Contains("KerbalEVA")) {
                    if (system.vessel.GetCrewCount() < system.vessel.GetCrewCapacity()) { //is there room?
                        if (GUILayout.Button("Beam target aboard")) {
                            system.lazorSound.Play(SoundType.TELEPORT);
                            MonoBehaviour.print("[Beaming " + target.name + " aboard]");
                            ((KerbalEVA)(target.rootPart.Modules["KerbalEVA"])).BoardPart(system.vessel.rootPart);
                            system.vessel.SpawnCrew();
                            system.vessel.ResumeStaging();
                            system.vessel.MakeActive();
                        } 
                    } else {
                        GUI.enabled = false;
                        GUILayout.BeginVertical();
                        GUILayout.Button("Beam target aboard");
                        GUILayout.Label("Not room in vessel");
                        GUILayout.EndVertical();
                        GUI.enabled = true;
                    }
                } else {
                    GUI.enabled = false;
                    GUILayout.BeginVertical();
                    GUILayout.Button("Beam target aboard");
                    GUILayout.Label("Target is out of range");
                    GUILayout.EndVertical();
                    GUI.enabled = true;
                }
            } else {
                GUI.enabled = false;
                GUILayout.BeginVertical();
                GUILayout.Button("Beam target aboard");
                GUILayout.Label("Teleport disabled at warp");
                GUILayout.EndVertical();
                GUI.enabled = true;
            } 
        }





		/// DEBUG 

		public static Vector3 MovePoint(Vector3 point, float increment){
			if (GUILayout.RepeatButton("x+")) {
				point += (new Vector3(increment, 0, 0));
            } if (GUILayout.RepeatButton("x-")) {
				point -= (new Vector3(increment, 0, 0));
            }
            if (GUILayout.RepeatButton("y+")) {
				point += (new Vector3(0, increment,0));
            } if (GUILayout.RepeatButton("y-")) {
				point -= (new Vector3(0, increment, 0));
            }
            if (GUILayout.RepeatButton("z+")) {
				point += (new Vector3(0, 0, increment));
            } if (GUILayout.RepeatButton("z-")) {
				point -= (new Vector3(0, 0, increment));
            }
			//MonoBehaviour.print((Vector3d)point);
			return point;
		}

		//debug : makes a yellow cross at a point
		public static GameObject Cross(Color c){
			GameObject o = new GameObject("DebugCross");
			LineRenderer lf = Util.GenericLazor(o.transform, Vector3.zero, 0.01f, c);
			lf.SetPosition(1, o.transform.InverseTransformDirection(o.transform.forward) * 1);
			LineRenderer lu = Util.GenericLazor(o.transform, Vector3.zero, 0.01f, c);
			lu.SetPosition(1, o.transform.InverseTransformDirection(o.transform.up) * 1);
			LineRenderer lr = Util.GenericLazor(o.transform, Vector3.zero, 0.01f, c);
			lr.SetPosition(1, o.transform.InverseTransformDirection(o.transform.right) * 1);

			LineRenderer lfi = Util.GenericLazor(o.transform, Vector3.zero, 0.01f, c);
			lfi.SetPosition(1, o.transform.InverseTransformDirection(-o.transform.forward) * 1);
			LineRenderer lui = Util.GenericLazor(o.transform, Vector3.zero, 0.01f, c);
			lui.SetPosition(1, o.transform.InverseTransformDirection(-o.transform.up) * 1);
			LineRenderer lri = Util.GenericLazor(o.transform, Vector3.zero, 0.01f, c);
			lri.SetPosition(1, o.transform.InverseTransformDirection(-o.transform.right) * 1);
			return o;
		}
		
		public static LineRenderer GenericLazor(Transform parent, Vector3 origin, float width, Color color) {
			GameObject o = new GameObject("DebugLazor");
			o.transform.parent = parent;
			o.transform.localEulerAngles = Vector3.zero;
			LineRenderer lazor = o.AddComponent<LineRenderer>();
			lazor.transform.parent = parent;
			lazor.useWorldSpace = false;
			lazor.transform.localPosition = origin;
			lazor.transform.localEulerAngles = Vector3.zero;
			lazor.material = new Material(Shader.Find("Particles/Additive"));
			lazor.SetWidth(width, width);
			lazor.SetVertexCount(2);
			lazor.SetPosition(0, Vector3.zero);
			lazor.SetPosition(1, parent.up * 100);
			lazor.SetColors(color, color);
			return lazor;
		}


    }



	//EXTENSIONS

	public static class VesselExtensions {
		/*private static Rect windowPos = new Rect(220,100,300,400);
		private static bool on;
		private static Part root;

		public static void PrintHierarchy(this Vessel vessel, Part p){
			UnityEngine.GUI.skin = Util.LazorSkin;
			on = GUILayout.Toggle(on, "Hierarchy");
			if(on) {
				root = p;
				windowPos = Util.ClampToScreen(GUILayout.Window(vessel.GetInstanceID(), windowPos, VesselGUI, "Hierarchy " + vessel.vesselName));
			}
		}
		
		private static void VesselGUI(int windowID){
			GUILayout.Label(root.name + " " + root.children.Count);
			Element("   |", root);
			GUI.DragWindow(new Rect(0, 0, windowPos.width, 30));
		}

		private static void Element(string a, Part p){
			using(List<Part>.Enumerator enumerator = p.children.GetEnumerator()) {
				while(enumerator.MoveNext()){
					GUILayout.Label(a+enumerator.Current.name + " (" + enumerator.Current.children.Count + ") " + 
					                (enumerator.Current.attachJoint==null?"null":enumerator.Current.attachJoint.connectedBody.name));
					Element(a + "   |", enumerator.Current);
				}
			}
		}*/
	}
}
